stages:
  - build
  - deploy

.docker_image: &docker_image
  image: docker:20.10.1
  variables:
    DOCKER_BUILDKIT: "1"
    DOCKER_DRIVER: overlay2
    DOCKER_TLS_CERTDIR: "/certs"
  services:
    - docker:20.10.1-dind

.login_gitlab_registry: &login_gitlab_registry
  - until docker info; do sleep 1; done
  - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY

variables:
  IMAGE_TAG: $CI_REGISTRY_IMAGE:$CI_COMMIT_SHORT_SHA

build_dev:
  stage: build
  extends: .docker_image
  before_script:
    - *login_gitlab_registry
  script:
    - docker build --build-arg GIT_HASH=$CI_COMMIT_SHA --build-arg GIT_VERSION=$CI_COMMIT_REF_NAME -t $IMAGE_TAG .
    - docker push $IMAGE_TAG
  except:
    - tags

build_tags:
  stage: build
  extends: .docker_image
  before_script:
    - *login_gitlab_registry
  script:
    - docker build --build-arg GIT_HASH=$CI_COMMIT_SHA --build-arg GIT_VERSION=$CI_COMMIT_REF_NAME -t $IMAGE_TAG .
    - docker push $IMAGE_TAG
  only:
    - tags


deploy_latest:
  stage: deploy
  extends: .docker_image
  before_script:
    - *login_gitlab_registry
  script:
    - docker pull $IMAGE_TAG
    - docker tag $IMAGE_TAG $CI_REGISTRY_IMAGE:latest
    - docker push $CI_REGISTRY_IMAGE:latest
  only:
    - tags

deploy-tags:
  stage: deploy
  extends: .docker_image
  before_script:
    - *login_gitlab_registry
  script:
    - docker pull $IMAGE_TAG
    - docker tag $IMAGE_TAG $CI_REGISTRY_IMAGE:$CI_COMMIT_TAG
    - docker push $CI_REGISTRY_IMAGE:$CI_COMMIT_TAG
  only:
    - tags

